<?php
/*
    <id>premiumbeat:mp3forsmf</id>
	<name>Premiumbeat Flash MP3 Player For SMF Forums</name>
	<version>1.9</version>
	<type>modification</type>
*/	

/*  This file is for mysql setup and transferring possible values from v1.71 or prior versions */


/* START - Mysql setup and transfers  */
global $modSettings, $db_prefix;

echo '<div style="background-color:black; border: 2px dotted green; display: block; height: auto; width: 75%; font-family:verdana; font-size:small; font-color: yellow; padding: 20px 20px 20px 20px;margin-left: auto; margin-right: auto;color: green;"><br />Premiumbeat Mp3 Player For SMF Forums.<br /><br />This installation copies older mysql values from your settings table to premiumbeat tables and neatly drops them from your settings table if necessary.<br /><hr /><br />';    

/*  Set variables and arrays  */
$mymusic = array();
$music = array();
$myset = array();
$setting['variable'] = array();
$setting['value'] = array();
$max = 9999;
$counter = 1;
$tally = 0;
$types = array('tag', 'playlist', 'enable', 'description', 'url');
$sets = array('myplaylist', 'height', 'width', 'autoplay', 'type', 'skin');
$forum_sets = array('reference', 'override', 'filename', 'forumlink', 'autoplay');

$new_columnsTypes = array(
                          'premiumbeat_mp3s' => array ('int(10) unsigned NOT NULL AUTO_INCREMENT', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL default 0', 'varchar(255) NOT NULL', 'varchar(255) NOT NULL'),				
		                  'premiumbeat_settings' => array ('int(10) unsigned NOT NULL AUTO_INCREMENT', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'varchar(255) NOT NULL'),
						  'premiumbeat_forum_settings' => array('int(10) unsigned NOT NULL AUTO_INCREMENT', 'varchar(255) NOT NULL', 'varchar(255) NOT NULL', 'int(10) unsigned NOT NULL', 'varchar(255) NOT NULL'));				

/*  Create premiumbeat tables if they do not exist  */
$checkit = false;
$table = 'premiumbeat_mp3s';
$checkit = check_table_existsPremium($table);
if ($checkit == false)
	{
		$result = db_query("CREATE TABLE {$db_prefix}{$table} 
                                       (
										`tag` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
										`playlist` INT(10) UNSIGNED NOT NULL,
										`enable` int(10) unsigned NOT NULL default 0,
										`description` varchar(255) NOT NULL,
										`url` varchar(255) NOT NULL,
										PRIMARY KEY (`tag`)) ", __FILE__, __LINE__);
		echo '<br />Table: ', $table, ' -> created with needed columns<br /><br /><hr />';
	}

$table = 'premiumbeat_settings';
$checkit = false;
$checkit = check_table_existsPremium($table);

if ($checkit == false) 
	{
		$result = db_query("CREATE TABLE {$db_prefix}{$table} 
								(
									`myplaylist` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
										`height` INT(10) UNSIGNED NOT NULL,
										`width` int(10) unsigned NOT NULL,
										`autoplay` int(10) unsigned NOT NULL,
										`type` int(10) unsigned NOT NULL,
										`skin` varchar(255) NOT NULL,
										PRIMARY KEY (`myplaylist`)) ", __FILE__, __LINE__);

		echo '<br />Table: ', $table, ' -> created with needed columns<br />';
	}
	
$table = 'premiumbeat_forum_settings';
$checkit = false;
$checkit = check_table_existsPremium($table);

if ($checkit == false) 
	{
		$result = db_query("CREATE TABLE {$db_prefix}{$table} 
								(
									`reference` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,										
										`override` varchar(255) NOT NULL,
										`filename` varchar(255) NOT NULL,
										`forumlink` int(10) unsigned NOT NULL,
										`autoplay` varchar(255) NOT NULL,										
										PRIMARY KEY (`reference`))", __FILE__, __LINE__);

		echo '<br />Table: ', $table, ' -> created with needed columns<br />';
	}
		
/*  Add extra needed columns into existing tables for columns only native to Premiumbeat  */
/*  This is necessary due to possible manual deletion or otherwise  */
$tableName = 'premiumbeat_settings';	
$request = false;
$i = 0;
$columnName = false;
foreach ($sets as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = db_query("ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType", __FILE__, __LINE__);				
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}			   
		    
$tableName = 'premiumbeat_mp3s';	
$request = false;
$i = 0;
$columnName = false;
foreach ($types as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = db_query("ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType ", __FILE__, __LINE__);				
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}	
			   
$tableName = 'premiumbeat_forum_settings';	
$request = false;
$i = 0;
$columnName = false;
foreach ($forum_sets as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = db_query("ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType", __FILE__, __LINE__);					
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}	

/*  Create needed reference if it does not exist  */
$a = false;
$tag = 1;
$a = check_ref($tag);
if ($a == false)
	{
		$request = db_query("DELETE FROM {$db_prefix}premiumbeat_forum_settings WHERE reference LIKE '$tag'", __FILE__, __LINE__);	
		$request = db_query("INSERT INTO `{$db_prefix}premiumbeat_forum_settings` (`reference`, `override`, `filename`, `forumlink`, `autoplay`) VALUES ('1', '1', 'my_music/music', '1', '99')", __FILE__, __LINE__);	
	}
			   
echo '<br /><hr />';
$config = 'premiumbeat_config';
$settings = 'premiumbeat_settings';
$showlink = 'premiumbeat_showlink';
$link = 'premiumbeat_link';

/*  Insert/reset default permission values  */
$request = db_query("DELETE FROM {$db_prefix}permissions WHERE permission LIKE '$config'", __FILE__, __LINE__);
$request = db_query("INSERT INTO `{$db_prefix}permissions` (`ID_GROUP`, `permission`, `addDeny`) VALUES ('2', 'premiumbeat_config', '1')", __FILE__, __LINE__);	
$request = db_query("DELETE FROM {$db_prefix}permissions WHERE permission LIKE '$settings'", __FILE__, __LINE__);
$request = db_query("INSERT INTO `{$db_prefix}permissions` (`ID_GROUP`, `permission`, `addDeny`) VALUES ('2', 'premiumbeat_settings', '1')", __FILE__, __LINE__);
$request = db_query("DELETE FROM {$db_prefix}permissions WHERE permission LIKE '$showlink'", __FILE__, __LINE__);
$request = db_query("INSERT INTO `{$db_prefix}permissions` (`ID_GROUP`, `permission`, `addDeny`) VALUES ('2', 'premiumbeat_showlink', '1')", __FILE__, __LINE__);
echo 'Premiumbeat Administration Permissions inserted/reset for Global Moderators and Admin staff<br /><br />';
echo '<br /><hr />';

/* Insert/rest default link setting */
$request = db_query("DELETE FROM {$db_prefix}settings WHERE variable LIKE '$link'", __FILE__, __LINE__);
$request = db_query("INSERT INTO `{$db_prefix}settings` (`variable`, `value`) VALUES ('premiumbeat_link', '1')", __FILE__, __LINE__);
echo 'Premiumbeat main setting for the popup link enabled<br /><br />';

/*  Check for v1.71 (or prior) mp3's and settings - drop them and put into arrays */
foreach ($sets as $set)
	{
	if (!empty($modSettings['customMusic_'.$set])) 
		{
			$custom = 'customMusic_' . $set;
			$myset[$set]  = $modSettings['customMusic_'.$set];
			db_query("DELETE FROM `{$db_prefix}settings` WHERE `{$db_prefix}settings`.`variable` = '$custom'", __FILE__, __LINE__);
		}
	else {$myset[$set] = 0;}
	}

if ($myset['skin'] == 0) {$myset['skin'] = '000000';}
$tally = 0;
while ($counter < $max)
	{
		foreach ($types as $type)
			{
				if (!empty($modSettings['customMusic_'.$type.'_'.$counter]))
 					{
						$tally = $counter;
						$it = 'customMusic_%_' . $counter;
						$music[$type][$counter] = $modSettings['customMusic_'.$type.'_'.$counter]; $tally = $counter;
						db_query("DELETE FROM `{$db_prefix}settings` WHERE `{$db_prefix}settings`.`variable` LIKE '$it'", __FILE__, __LINE__);
					}

			}
		$counter++;
	}

/*  Alter existing premiumbeat tables/columns with mp3's and settings from v1.71 (or prior)  */
$result1 = array();
$val = array();
$mp3_setting['tag'] = array();
$amt_values = 0;
$a = false;
$a = checkFieldPremium('premiumbeat_mp3s','tag');
if ($a == true)
	{
		$result1 = db_query("SELECT * FROM {$db_prefix}premiumbeat_mp3s ", __FILE__, __LINE__);
		$amt_values = mysql_num_rows($result1); 
		mysql_free_result($result1);
	}
$x = 0;
if ($amt_values > 0)
	{   
		$x = 1;      
		$result = db_query("SELECT tag FROM {$db_prefix}premiumbeat_mp3s ORDER BY tag ASC", __FILE__, __LINE__);      
		while ($val = mysql_fetch_assoc($result))
			{                               
				$mp3_setting['tag'][$x] = $x;                			
				$x++;
			}  
		mysql_free_result($result);
	}

$tableName = 'premiumbeat_mp3s';
$columnName = 'tag';
$check = false;
$x = 1;
while ($x < ($tally+1))
	{
		if (empty($music['tag'][$x])) {$music['tag'][$x] = false;}
		$value = $music['tag'][$x];
		if (empty($mp3_setting['tag'][$x])) {$mp3_setting['tag'][$x] = false;}
		if (empty($music['playlist'][$x])) {$music['playlist'][$x] = 0;}
		$music['playlist'][$x]++;
		if ($value == true)
			{				
				$request = db_query("DELETE FROM {$db_prefix}premiumbeat_mp3s WHERE tag LIKE {$value}", __FILE__, __LINE__);
				$request = db_query("INSERT INTO `{$db_prefix}premiumbeat_mp3s` (`tag`) VALUE ('$value')", __FILE__, __LINE__);
			}
		$x++;
	}
$count = 1;
if ($tally > 0)
	{
		while ($count < ($tally + 1))
			{
				$tableName = 'premiumbeat_mp3s';
				foreach ($types as $columnName)
					{
						if ($columnName == 'enable' && empty($music['enable'][$count])) 
							{$music['enable'][$count] = false;}
						if ($columnName == 'enable' && ($music['enable'][$count] == false) && ($music['tag'][$count] == true)) 
							{createpremiumval($tableName, $columnName, '0', $count);}
						elseif (($columnName == 'playlist') && ($music['playlist'][$count] == 1) && ($music['tag'][$count] == true))
							{
								$a = $music['playlist'][$count];
								createpremiumval($tableName, 'playlist', $a, $count);
							} 
						elseif ((!empty($music[$columnName][$count])) && ($music['tag'][$count] == true))
							{
								$value = $music[$columnName][$count];
								if ($columnName == true)
									{createpremiumval($tableName, $columnName, $value, $count);} 
							}
					}
				$count++;
				echo '<hr />';
			}
	}
$a = false;
$tally2 = 0;
$a = checkFieldPremium('premiumbeat_mp3s','tag');
if ($a == true)
	{
		$result1 = db_query("SELECT * FROM {$db_prefix}premiumbeat_mp3s", __FILE__, __LINE__);
		$tally2 = mysql_num_rows($result1); 
		mysql_free_result($result1);
	}


/*  Create default settings for playlist 1 if they do not exist  */
$result1 = array();
$amt_values = 0;
$a = false;
$playlist = 1;
$a = checkFieldPremium('premiumbeat_settings','myplaylist');
if ($a == true)
	{
		$result1 = db_query("SELECT myplaylist FROM {$db_prefix}premiumbeat_settings WHERE myplaylist = 1 ", __FILE__, __LINE__);
		while ($val1 = mysql_fetch_assoc($result1))
			{
				$check = false;
				if (empty($val1['myplaylist'])) {$val1['myplaylist'] = false;}
				if ($val1['myplaylist'] == 1)	{$check = true;}
			}
		mysql_free_result($result1);
	
	if ($check == false)
		{   
	    	$myval = 1;
			$request = db_query("DELETE FROM {$db_prefix}premiumbeat_settings WHERE myplaylist LIKE {$myval}", __FILE__, __LINE__);
			$request = db_query("INSERT INTO {$db_prefix}premiumbeat_settings (`myplaylist`, `height`, `width`, `autoplay`, `type`, `skin`) VALUES ('1', '190', '220', '0', '0', '000000') ", __FILE__, __LINE__);	
		}
	echo '<hr /><br />Default settings for playlist 1 have been set/modified.<br />';
	}
echo '<hr /><br />Installation complete.<br /><br />Please adjust necessary settings and add your source mp3 url from the Admin page.<br /><br />';
echo '<div style="text-align:center;"><a href="'. $scripturl . '?action=custom_mp3;">Configure Premiumbeat</a>  -  <a href="'. $scripturl .'?action=admin">Administration</a>  -  <a href="'. $scripturl .'">Forum</a><br /><br />** You will be redirected to Premiumbeat Configuration in 10 seconds **</div><br /><br /></div><br /><br />';
$time = 10; 
$url = $scripturl . '?action=custom_mp3;';
@header("Refresh: $time; url=$url"); 
/* END - Mysql setup and transfers  */

/* Check if the column exists */
function checkFieldPremium($tableName,$columnName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium($tableName);
		if ($checkTable == true)
			{
				global $db_prefix;
				$check = false;
				$checkval = false;
				$check = db_query("DESCRIBE {$db_prefix}$tableName $columnName ", __FILE__, __LINE__);
				$checkval = mysql_num_rows($check);
				mysql_free_result($check);
				if ($checkval > 0) {return true;}
			}
		return false;
	} 

/*  Returns amount of columns in a table  */
function checkTablePremium($tableName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium($tableName);
		if ($checkTable == true)
			{
				global $db_prefix;
				$check = false;
				$checkval = false;
				$check = db_query("DESCRIBE {$db_prefix}$tableName ", __FILE__, __LINE__);
				$checkval = mysql_num_rows($check);
				mysql_free_result($check);
				if ($checkval > 0) {return $checkval;}
			}
		return false;
	} 

/*  Check if table exists  */
function check_table_existsPremium($table)
	{
		global $db_prefix;
		$check = false;
		$checkval = false;
		$check = db_query("SHOW TABLES LIKE '{$db_prefix}$table' ", __FILE__, __LINE__);
		$checkval = mysql_num_rows($check);
		mysql_free_result($check);
		if ($checkval >0) {return true;}
		return false;
	}


/*  Update table -> column -> value   */
function createpremiumval($tableName, $columnName, $value, $tag) 
	{
		global $db_prefix;
		$i = 0;
		$request = false;   
		if (empty($tableName) || empty($columnName) || empty($tag)) {return;}
		if (empty($value)) {$value = false;}
		$request = db_query("UPDATE {$db_prefix}$tableName SET $columnName = '{$value}' WHERE `{$db_prefix}$tableName`.`tag` = {$tag} LIMIT 1 ", __FILE__, __LINE__);
		echo 'Song id: ', $tag, ' ', $columnName, ': ', $value, ' - updated in - ', $tableName,'<br />'; 						 
	}
	
/* Check for reference value */
function check_ref($tag)
	{
		global $db_prefix;		
		$result2 = db_query("SELECT reference FROM {$db_prefix}premiumbeat_forum_settings WHERE reference = '$tag' LIMIT 1", __FILE__, __LINE__);
		$result3 = mysql_num_rows($result2);	
		mysql_free_result($result2);		
		if ($result3 > 0) {return true;}
		return false;
	}	
?>