<?php
// Version: 1.9; premiumbeat

/*     Main admin settings file for the premiumbeat mp3 Mod     */
/*          c/o Underdog @ http://askusaquestion.net           */  
/*                     SMF 2 Version						*/

if (!defined('SMF'))
	die('Hacking attempt...');

function custom_mp3_forum_settings()
{
	global $scripturl, $txt, $context, $sourcedir;
	isAllowedTo('premiumbeat_settings');
	$context['robot_no_index'] = true;	
	require_once($sourcedir . '/ManageServer.php');	
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['customMusic_tabtitle'];	
		
	/*  Fill $context with save data for the forum settings if they exist  */	
	$setting_types = array('override', 'forumlink', 'filename', 'autoplay');	
	foreach ($setting_types as $setting_type)
		{			
			if (empty($_REQUEST[$setting_type][0])) {$_REQUEST[$setting_type][0] = false;}				
			$context[$setting_type] = $_REQUEST[$setting_type][0];			
		}
		 
	if (empty($_REQUEST['mainlink'][0])) {$_REQUEST['mainlink'][0] = false;}				
	$context['mainlink'] = $_REQUEST['mainlink'][0];		
				
	$subActions = array(
					'PremiumbeatSettings' => array('SettingsCustomMusic'),										
	);
		
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'PremiumbeatSettings'; 

	if (isset($subActions[$_REQUEST['sa']][1]))
		isAllowedTo('premiumbeat_settings');

	$subActions[$_REQUEST['sa']][0]();
}

function SettingsCustomMusic()
{

	global $txt, $scripturl, $context, $smcFunc, $sourcedir, $db_prefix, $modSettings;
	loadLanguage('Modifications');	
	$context['tag'] = array();
	$context['robot_no_index'] = true;	
	isAllowedTo('premiumbeat_settings');
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['premiumbeat_forum'];
	$a = false;
	$count = 0;
	$tableName = 'premiumbeat_forum_settings';	
	$setting_types = array('override', 'forumlink', 'filename', 'autoplay');	
	if (empty($modSettings['premiumbeat_link'])) {$modSettings['premiumbeat_link'] = 0;}
	$context['myFlink'] = $txt['premiumbeat_disabled'];			
	if ((int)$modSettings['premiumbeat_link'] > 0) {$context['myFlink'] = $txt['premiumbeat_enabled'];}	
	$a = false;	
	
	/*  Check for new settings values and save to database if necessary */
	foreach ($setting_types as $setting_type)
		{		
			if (empty($context[$setting_type])) {$context[$setting_type] = false; continue;}	
			if ($context['forumlink'] == 2 && $setting_type == 'forumlink')	
				{	
					$columnName = 'forumlink';	
					$tag = 1;
					$value = 0;			
					$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value}' WHERE `{$db_prefix}$tableName`.`reference` = {$tag} LIMIT 1");
					continue;
				}
			if ($setting_type == 'override')	
				{	
					$columnName = $setting_type;					
					$value = premium_number_filter($context[$setting_type]);
					$tag = 1;	
					if((int)$value < 1 || (int)$value > 99) {$value = 1;}																	
					createpremiumval_setting($tableName, $setting_type, $tag, $value);		
					continue;
				}	
			if ($setting_type == 'autoplay')	
				{	
					$columnName = $setting_type;					
					$value = premium_number_filter($context[$setting_type]);
					$tag = 1;	
					if((int)$value < 1 || (int)$value > 99) {$value = 1;}																	
					createpremiumval_setting($tableName, $setting_type, $tag, $value);		
					continue;
				}				
			if ($context[$setting_type] != false)	
				{	
					$columnName = $setting_type;	
					$value = premium_folder_filter($context[$setting_type]);
					$tag = 1;					
					$value = substr($value, 0, 254);													
					createpremiumval_setting($tableName, $setting_type, $tag, $value);		
					continue;
				}			
		}

	/* Enable/Disable Premiumbeat link */					
	$mysetting = 'premiumbeat_link';		
	if ($context['mainlink'] == 2)	
		{
			$value = 0;
			$context['myFlink'] = $txt['premiumbeat_disabled'];	
			$premiumUpdate = array($mysetting => $value);
			updateSettings($premiumUpdate);
											
		}
	if ($context['mainlink'] == 1)	
		{					
			$value = 1;						
			$premiumUpdate = array($mysetting => $value);
			updateSettings($premiumUpdate);											
			$context['myFlink'] = $txt['premiumbeat_enabled'];													
		}					
				
	/* START - Read database entries for premiumbeat forum settings */
	$a = false;
	$a = checkFieldPremium3($tableName,'reference');
	if ($a == false) {fatal_lang_error('customMusic_error', false);}	
	$result1 = array();
	$val = false;	
	$query = 'reference = 1';	
	$result1 = $smcFunc['db_query']('', "SELECT reference, override, forumlink, filename, autoplay FROM {db_prefix}premiumbeat_forum_settings WHERE {$query}");
	while ($val = $smcFunc['db_fetch_assoc']($result1))
		{
			foreach ($setting_types as $setting_type)
				{					
					if (empty($val[$setting_type])) {$val[$setting_type] = false;}
					$context[$setting_type] = $val[$setting_type];
				}			
					
		}
	$smcFunc['db_free_result']($result1);			
	/* END - Read databse entries for premiumbeat forum settings */		
	
	/*  Set the $context for the tabtitle, post url and all mp3 tags for the display template */
	$context['settings_title'] = $txt['premiumbeat_forum'];
	$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat_settings;sa=PremiumbeatSettings;' . $context['session_var'] . '=' . $context['session_id'] . ';save';			
	/*  Display the template and all the tags.  */
	$context['sub_template'] = 'customMusic_settings_page';	
	$context['mylink'] = $txt['premiumbeat_disabled'];		
	if ($context['forumlink'] == 1) {$context['mylink'] = $txt['premiumbeat_enabled'];}
	
	$context['myFlink'] = $txt['premiumbeat_disabled'];			
	if ((int)$modSettings['premiumbeat_link'] > 0) {$context['myFlink'] = $txt['premiumbeat_enabled'];}
		
	$context['toggle'] = '<script type="text/javascript">	
	function changeLinkD(){
	   document.getElementById("updateLink").innerHTML = "Enabled";
	}
	function changeLinkE(){
 	  document.getElementById("updateLink").innerHTML = "Disabled";
	}
	function changeFLinkD(){
	   document.getElementById("updateFLink").innerHTML = "Enabled";
	}
	function changeFLinkE(){
 	  document.getElementById("updateFLink").innerHTML = "Disabled";
	}	
	</script>'; 	
	loadTemplate('CustomMusicForum');	
}
	  
/* Check if the column exists */
function checkFieldPremium3($tableName,$columnName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium3($tableName);
		if ($checkTable == true)
			{
				global $db_prefix, $smcFunc;
				$check = false;
				$checkval = false;
				$check = $smcFunc['db_query']('', "DESCRIBE {$db_prefix}$tableName $columnName");
				$checkval = $smcFunc['db_num_rows']($check);
				$smcFunc['db_free_result']($check);
				if ($checkval > 0) {return true;}
			}
		return false;
	} 

/*  Check if table exists  */
function check_table_existsPremium3($table)
	{
		global $db_prefix, $smcFunc;
		$check = false;
		$checkval = false;
		$check = $smcFunc['db_query']('', "SHOW TABLES LIKE '{$db_prefix}$table'");
		$checkval = $smcFunc['db_num_rows']($check);
		$smcFunc['db_free_result']($check);
		if ($checkval >0) {return true;}
		return false;
	}

/*  Update table -> column -> value for premiumbeat forum settings */
function createpremiumval_setting($tableName, $columnName, $tag, $valuex) 
	{
		global $smcFunc, $db_prefix;
		$value = cleanPremiumbeatQuery($valuex);
		$i = 0;
		$request = false;   
		if (empty($tableName) || empty($columnName) || empty($tag)) {return;}
		if (empty($value)) {$value = false;}
		$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value}' WHERE `{$db_prefix}$tableName`.`reference` = {$tag} LIMIT 1");
								 
	}	
	
/* Foldername filter */	
function premium_folder_filter($folder)
{	
	$filtered_folder = "";
	$patterns = array("/\s/","/\&/","/\+/","/delete/i", "/update/i","/union/i","/insert/i","/drop/i","/http/i","/--/i");  
	$folder = preg_replace($patterns, "_" , $folder);
	for ($i=0;$i<strlen($folder);$i++)
		{
			$current_char = substr($folder,$i,1);
			if (ctype_alnum($current_char) == TRUE || $current_char == "_" || $current_char == "/" || $current_char == "-")
				{$filtered_folder .= $current_char;}
		}     
	return $filtered_folder;
}	

/* Playlist number filter */	
function premium_number_filter($folder)
{	
	$filtered_folder = "";
	$patterns = array("/\s/","/\&/","/\+/","/\-/","/delete/i", "/update/i","/union/i","/insert/i","/drop/i","/http/i","/--/i");  
	$folder = preg_replace($patterns, "" , $folder);
	for ($i=0;$i<strlen($folder);$i++)
		{
			$current_char = substr($folder,$i,1);
			if (ctype_alnum($current_char) == TRUE)
				{$filtered_folder .= $current_char;}
		}     
	return $filtered_folder;
}	

/* mysql query filter */
function cleanPremiumbeatQuery($string)
{
  if(get_magic_quotes_gpc())  
  {
    $string = stripslashes($string);
  }
  if (phpversion() >= '4.3.0')
  {
    $string = mysql_real_escape_string($string);
  }
  else
  {
    $string = mysql_escape_string($string);
  }
  return $string;
}	
?>