<?php
// Version: 1.9; premiumbeat

/*     Main admin settings file for the premiumbeat mp3 Mod     */
/*          c/o Underdog @ http://askusaquestion.net           */  
/*                     SMF 2 Version						*/

if (!defined('SMF'))
	die('Hacking attempt...');

function custom_mp3()
{
	global $scripturl, $txt, $context, $sourcedir;
	isAllowedTo('premiumbeat_config');
	$context['robot_no_index'] = true;	
	require_once($sourcedir . '/ManageServer.php');	
	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['customMusic_tabtitle'];	
	
	/*  Request needed data from the url  */
	$context['lists']['mylist'] = !empty($_REQUEST['playlist']) ? (int) $_REQUEST['playlist'] : 0;	
	$context['edit_tag'] = !empty($_REQUEST['tag']) ? (int) $_REQUEST['tag'] : 0;	
	$context['xtag']['tag'] = !empty($_REQUEST['edit']) ? (int) $_REQUEST['edit'] : 0;	
	$context['queryPlaylist'] 	= !empty($_REQUEST['queryPlaylist']) ? (int) $_REQUEST['queryPlaylist'] : 0;		
	$context['perm_id_group'] = !empty($_REQUEST['perms']) ? (int) $_REQUEST['perms'] : 0;

		
	/*  Fill $context with save data for the playlist if it exists  */
	$list_types = array('height', 'width', 'autoplay', 'type', 'skin', 'perms');	
	foreach ($list_types as $list_type)
		{						
			if (empty($_REQUEST[$list_type])) {$_REQUEST[$list_type] = false;}
			$context['lists'][$list_type] = $_REQUEST[$list_type];	
			if (empty($context['lists']['width'][0])) {$context['lists']['width'][0] = -1;} 
			if (empty($context['lists']['height'][0])) {$context['lists']['height'][0] = -1;} 
			if ($context['lists']['width'][0] == false) {$context['lists']['width'][0] = -1;} 
			if ($context['lists']['height'][0] == false) {$context['lists']['height'][0] = -1;}					
		} 
	
	/*  Fill $context with save data for the new or edited tag if it exists  */	
	$edit_types = array('playlist', 'description', 'url', 'enable');	
	foreach ($edit_types as $edit_type)
		{			
			if (empty($_REQUEST[$edit_type])) {$_REQUEST[$edit_type] = false;}				
			$context['xtag'][$edit_type] = $_REQUEST[$edit_type];			
		}	
				
	$subActions = array(
					'BrowsePremiumbeat' => array('BrowseCustomMusic'),					
					'SettingsPremiumbeat' => array('SettingsCustomMusic'),
					'PlaylistPremiumbeat' => array('PlaylistCustomMusic'),
					'EditPremiumbeat' => array('EditCustomMusic'),
	);
		
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'BrowsePremiumbeat'; 

	if (isset($subActions[$_REQUEST['sa']][1]))
		isAllowedTo('admin_forum');

	$subActions[$_REQUEST['sa']][0]();
}

function BrowseCustomMusic()
{

	global $txt, $scripturl, $context, $smcFunc, $sourcedir, $db_prefix;
	loadLanguage('Modifications');	
	$context['tag'] = array();
	$context['robot_no_index'] = true;	
	isAllowedTo('premiumbeat_config');
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['customMusic_tabtitle2'];
	$a = false;
	$count = 0;
	$tableName = 'premiumbeat_mp3s';
	$columns_mp3s = array('tag', 'playlist', 'enable', 'description', 'url');
	$edit_types = array('playlist', 'enable', 'description', 'url');	
	if (empty($context['xtag']['tag'])) {$context['xtag']['tag'] = 0;}
	$a = false;
	$mytag = $context['xtag']['tag'];
	/*  Insert bogus values for a new tag - the actual data can be updated in the next query  */
	if ($mytag > 0)
		{
			$a = check_mp3($mytag);
			if ($a == false)
				{
					$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_mp3s WHERE tag LIKE {string:mytag}',
														array('mytag' => $mytag));
					$request = $smcFunc['db_query']('', "INSERT INTO {db_prefix}premiumbeat_mp3s (`tag`, `playlist`, `enable`, `description`, `url`) 
															VALUES ({int:mytagx} , '1', '1', false, false)",array('mytagx' => $mytag,));
				}
		}
	/*  Check for new/edit mp3 values and save to database if necessary */
	foreach ($edit_types as $edit_type)
		{		
			if (empty($context['xtag'][$edit_type])) {$context['xtag'][$edit_type] = false; continue;}	
			if ($context['xtag']['tag'] > 0 && (int)$context['xtag']['enable'] > 1 && $edit_type == 'enable')	
				{	
					$columnName = 'enable';	
					$tag = $context['xtag']['tag'];
					$value = 0;			
					$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value}' WHERE `{$db_prefix}$tableName`.`tag` = {$tag} LIMIT 1");
					continue;
				}		
			if ($context['xtag'][$edit_type] == true && $context['xtag']['tag'] > 0) 
				{									 					
					$tag = $context['xtag']['tag'];
					$value = $context['xtag'][$edit_type];
					if ($edit_type == 'url' && $value == true)
						{$value = substr($value, 0, 254);}																		
					createpremiumval_mp3('premiumbeat_mp3s', $edit_type, $tag, $value);				
				}		
		} 
	
	
	/* START - Read database entries for mp3's */
	$a = false;
	$a = checkFieldPremium2('premiumbeat_mp3s','tag');
	if ($a == false) {fatal_lang_error('customMusic_error', false);}
	$list = array();
	$result1 = array();
	$val = false;
	$song = 1;	
	$check_playlist = array();
	if (!empty($context['queryPlaylist']))
		{			
			if ((int)$context['queryPlaylist'] > 0) {$query = 'playlist=' . (int)$context['queryPlaylist'];}
		}
	else
		{$query = 'tag > 0';}	
	$result1 = $smcFunc['db_query']('', "SELECT tag, playlist, enable, description, url FROM {db_prefix}premiumbeat_mp3s WHERE {$query} ORDER BY tag ASC");
	while ($val = $smcFunc['db_fetch_assoc']($result1))
		{	
			if ((empty($val['url'])) || (empty($val['tag']))) {continue;}	 
			if ($val['tag'] == 0) {continue;}	
			$check_playlist[$song-1] = $val['playlist'];
			if (empty($val['description'])) {$val['description'] = $txt['none'];}                          
			$context['tag'][$song] = $val['tag'];
			$context['playlist'][$song] = $val['playlist'];
			$context['enable'][$song] = $val['enable'];
			$context['description'][$song] = $val['description'];
			$context['url'][$song] = $val['url'];	
			if ($context['enable'][$song] == 1) {$context['status'][$song] = $txt['premiumbeat_enabled'];}
			else {$context['status'][$song] = $txt['premiumbeat_disabled'];}		
			$song++;
					
		}
	$smcFunc['db_free_result']($result1);
	$context['premiumbeat_count'] = $song;
	$count = $song -1;		
	/* END - Read databse entries for mp3's */
	
	/* Fill playlist with default data if the needed playlist data does not exist */
	foreach ($check_playlist as $play)
		{
			if(empty($play)) {continue;}
			$a = false;
			$a = check_playlist($play);
			if ($a == false)
				{
					$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_settings WHERE myplaylist LIKE {string:list}',
														array('list' => $play));
					$request = $smcFunc['db_query']('', "INSERT INTO {db_prefix}premiumbeat_settings (`myplaylist`, `height`, `width`, `autoplay`, `type`, `skin`) 
															VALUES ({int:val} , '210', '185', '1', '0', '000000')",array('val' => $play,));	
				}
		
		}
		
	/*   Saving?   */
	if (isset($_REQUEST['save']))
		{

			/*  Mark the ones to delete.  */
			if (isset($_POST['delete']) && is_array($_POST['delete']))
				{
					$delete_tags = $_POST['delete'];								
					$songs = 1;									
					foreach ($context['tag'] as $song)
						{							
							$i = (int)$song;																		
							/* Delete the mp3 if it was opted */
							foreach ($delete_tags as $check_tag)
								{
									if ((int)$check_tag == $i)
										{																			
											$tableName = 'premiumbeat_mp3s';											
											$request = $smcFunc['db_query']('', "DELETE FROM `{db_prefix}$tableName` WHERE `{db_prefix}$tableName`.`tag` = '$i'");														
											
										}			
								}
									
						}						
				}				
			elseif (isset($_POST['enable']) && is_array($_POST['enable']))
				{					
					$enable_tags = $_POST['enable'];					
					$songs = 1;	
					$toggle = 0;						
					foreach ($context['tag'] as $song)
						{							
							$i = (int)$song;							
							foreach ($enable_tags as $check_mp3x)
								{									
									if ((int)$check_mp3x == $i)								
										{																				
											$request = $smcFunc['db_query']('', 'UPDATE {db_prefix}premiumbeat_mp3s SET enable = IF(enable=1, 0, 1)
																				 WHERE tag = {int:mp3}',array('mp3' => $i,'change' => $toggle,));									 
										}	
											
								}								
						}							
				}			
			else 
				{$delete_tags = array(); $enable_tags = array(); $track = 0;}		
		 
			redirectexit('action=admin;area=premiumbeat;sa=BrowsePremiumbeat;' . $context['session_var'] . '=' . $context['session_id'] . ';');
		}

	/*  Set the $context for the tabtitle, post url and all mp3 tags for the display template */
	$context['settings_title'] = $txt['customMusic_tabtitle2'];
	$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat;sa=BrowsePremiumbeat;' . $context['session_var'] . '=' . $context['session_id'] . ';save';			
	/*  Display the template and all the tags.  */
	$context['sub_template'] = 'customMusic_page';		
	$context['check_all'] = '<script type="text/javascript">
	function Check(chk)
	{		
		if(document.mysongs.Check_All.value=="Check All")
		{
			for (i = 0; i < chk.length; i++)
			chk[i].checked = true ;
			document.mysongs.Check_All.value="UnCheck All";
		}
		else
		{
			for (i = 0; i < chk.length; i++)
			chk[i].checked = false ;
			document.mysongs.Check_All.value="Check All";
		}
	}
	</script>'; 	
	loadTemplate('CustomMusic');	
}

function EditCustomMusic()
{
	
	global $txt, $scripturl, $context, $smcFunc;
	loadLanguage('Modifications');	
	$context['robot_no_index'] = true;	
	isAllowedTo('premiumbeat_config');
	$context['premiumbeat_edit'] = $txt['premiumbeat_edit'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['customMusic_tabtitle5'];
	$edit_types = array('playlist', 'enable', 'description', 'url');	
	$a = false;
	$a = checkFieldPremium2('premiumbeat_mp3s','tag');
	if ($a == false) {fatal_lang_error('customMusic_error', false);}	
	$edit_tag = !empty($_REQUEST['tag']) ? (int) $_REQUEST['tag'] : 0;		
	$result1 = array();
	$val = false;
	$song = 1;
	$result1 = $smcFunc['db_query']('', "SELECT tag, playlist, enable, description, url FROM {db_prefix}premiumbeat_mp3s WHERE (tag > 0) ORDER BY tag ASC");
	while ($val = $smcFunc['db_fetch_assoc']($result1))
		{	
			if ((empty($val['url'])) || (empty($val['tag']))) {continue;}	 
			if ($val['tag'] == 0) {continue;}	
			if (empty($val['description'])) {$val['description'] = $txt['none'];}                          
			$context['tag'][$song] = $val['tag'];
			$context['playlist'][$song] = $val['playlist'];
			$context['enable'][$song] = $val['enable'];
			$context['description'][$song] = $val['description'];
			$context['url'][$song] = $val['url'];	
			if ($context['enable'][$song] == 1) {$context['status'][$song] = $txt['premiumbeat_enabled'];}
			else {$context['status'][$song] = $txt['premiumbeat_disabled'];}		
			$song++;		
		}
	$smcFunc['db_free_result']($result1);
	$context['premiumbeat_count'] = $song;
	$count = $song;		
	/* END - Read databse entries for mp3's */
	              
	/*  Determine the next available numerical tag reference or if the tag being edited exists */
	$context['number_tag'] = 1;
	$context['track_id'] = 0;
	$i = 1;	
	$mycheck = false;
	$edit = false;	
	if ($count > 0)
		{			
			while ($i < ($count + 1))
				{	
					if (empty($context['tag'][$i])) {$context['tag'][$i] = $i;}	
					if ($context['tag'][$i] == (int)$edit_tag)
						{
							$edit = true;
							$mycheck = true;
							$context['number_tag'] = (int)$edit_tag;
							$tag = $context['number_tag'];
							$context['track_id'] = $i;	
							break;												
						}	
											
					if (($context['tag'][$i] != $i) && $mycheck == false)
						{																										
							$mycheck = true;
							$context['premiumbeat_edit'] = $txt['premiumbeat_edit_add'];
							$context['number_tag'] = $i;
							$tag = $context['number_tag'];
							$context['track_id'] = $i;	
							foreach ($edit_types as $mytype)
								{$context[$mytype][$i] = false;}
							$context['playlist'][$i] = 1;
							$context['enable'][$i] = 1;																				
						}					
					
					$i++;						
				}			
		}		
	if ($context['track_id'] == 0) 
		{
			$context['premiumbeat_edit'] = $txt['premiumbeat_edit_add'];
			$context['track_id'] = $count;
			$context['number_tag'] = $count; 
			$context['playlist'][$count] = 1;
			$context['enable'][$count] = 1;
			$context['description'][$count] = false;
			$context['url'][$count] = false;
		}		
	$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat;sa=BrowsePremiumbeat;edit=' . $context['number_tag'] . ';' . $context['session_var'] . '=' . $context['session_id'] . ';save;';
	$context['settings_title'] = $txt['customMusic_tabtitle'];	
	/*  Display the edit mp3 template.  */
    $context['sub_template'] = 'customMusic_edit';
	$context['xenable'] = $txt['premiumbeat_disabled'];	
	$track = $context['track_id'];	
	if ($context['enable'][$track] == 1) {$context['xenable'] = $txt['premiumbeat_enabled'];}	
	$context['toggle'] = '<script type="text/javascript">
	function changeEnableD(){
 	  document.getElementById("updateEnable").innerHTML = "Disabled";
	}
	function changeEnableE(){
 	  document.getElementById("updateEnable").innerHTML = "Enabled";
	}
	</script>'; 	
	loadTemplate('CustomMusicEdit');	
}

function SettingsCustomMusic()
	{
	global $txt, $scripturl, $context, $smcFunc, $db_prefix, $sourcedir;
	loadLanguage('Modifications');	
	$context['sets'] = array();
	$context['robot_no_index'] = true;	
	isAllowedTo('premiumbeat_config');
	require_once($sourcedir . '/Subs-Members.php');
	if (!empty($context['queryPlaylist']))
		{			
			if ((int)$context['queryPlaylist'] > 0)
				{
					redirectexit('action=admin;area=premiumbeat;sa=BrowsePremiumbeat;queryPlaylist=' . (int)$context['queryPlaylist'] . ';' . $context['session_var'] . '=' . $context['session_id'] . ';');
				}
			
		}	
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['customMusic_tabtitle3'];
	$a = false;
	$b = false;
	$count = 0;
	$columns_settings = array('myplaylist', 'type', 'height', 'width', 'autoplay', 'skin');
	$permission_sets = array('id_group', 'permission', 'add_deny');
	$a = checkFieldPremium2('premiumbeat_settings','myplaylist');
	$b = checkFieldPremium2('premiumbeat_mp3s','tag');
	if ($a == false || $b == false) {fatal_lang_error('customMusic_error', false);}	
	$result1 = array();
	$playlists = 1;
	$track = 0;
	$context['all_playlists'] = array();
	$checkit = false;
	
	$check_list = 0;
	if (!empty($context['lists']['mylist'])) {$check_list = $context['lists']['mylist'];}
	$list_types = array('height', 'width', 'autoplay', 'type', 'skin', 'perms');	
	foreach ($list_types as $list_type)
		{
			if (empty($context['lists'][$list_type][0])) {$context['lists'][$list_type][0] = false;}			
			if ($context['lists'][$list_type][0] == true && $check_list > 0) 
				{					
					$value = $context['lists'][$list_type][0];	
					if ((int)$value < 0) {$value = 0;}				 			
					if ($list_type == 'autoplay')
						{
							if ((int)$value > 1) {$value = 0;}
							$request = $smcFunc['db_query']('', 'UPDATE {db_prefix}premiumbeat_settings SET autoplay = {int:autox}
																				 WHERE myplaylist = {int:listx}',array('listx' => $check_list, 'autox' => $value));
							continue;
						}
					elseif ($list_type == 'type')
						{
							if ((int)$value > 1) {$value = 0;}
							$request = $smcFunc['db_query']('', 'UPDATE {db_prefix}premiumbeat_settings SET type = {int:typex}
																				 WHERE myplaylist = {int:listx}',array('listx' => $check_list, 'typex' => $value,));
							continue;
						}					
					elseif ($list_type == 'skin')
						{
							$value2 = premium_hex_filter($value);
							createpremiumval_settings('premiumbeat_settings', $list_type, $value2, $check_list);	
						}
					elseif ($list_type == 'perms' && $context['lists']['perms'][0] == true)
						{
							$columnName1 = 'premiumbeat_playlist_'. $context['lists']['mylist'];
							$columnName2 = 'premiumbeat_playlist_*';
							$tableName2 = 'permissions';
							if ($context['lists']['perms'][0] == true)
								{$request = $smcFunc['db_query']('', "DELETE FROM `{db_prefix}$tableName2` WHERE `{db_prefix}$tableName2`.`permission` = '$columnName1'");}
							foreach ($context['lists']['perms'] as $value)
								{
								$value = (int)$value;									
								if ($value == 1) {$value = 999;}	
								$request = $smcFunc['db_query']('', "DELETE FROM `{db_prefix}$tableName2` 
								WHERE (`{db_prefix}$tableName2`.`id_group` LIKE '$value') AND (`{db_prefix}$tableName2`.`permission` RLIKE '$columnName2')");																		
								if ($value != -999)
									{						
										$request = $smcFunc['db_query']('', "INSERT INTO `{db_prefix}$tableName2` (`id_group`, `permission`, `add_deny`)
										VALUES ('$value' , '$columnName1', '1')");
									}		
								}	
							continue;	
						} 		
					else
						{							
							createpremiumval_settings('premiumbeat_settings', $list_type, $value, $check_list);	
						}	
					
				}
		}		

		/*  Retrieve all the different playlists from the mp3 list  */
	$result1 = $smcFunc['db_query']('', "SELECT playlist FROM {db_prefix}premiumbeat_mp3s WHERE (tag > 0) ORDER BY tag ASC");
	while ($val = $smcFunc['db_fetch_assoc']($result1))
		{	
			if (empty($val['playlist'])) {continue;}
			$tracking[$track] = $val['playlist'];
			foreach ($tracking as $tracks)
				{					
					if (!in_array($tracks, $context['all_playlists']))
					 	{   							
							$context['all_playlists'][$playlists] = $val['playlist'];	
							$playlists++;
						}	
				}			
			
			$track++;	
		}
	$smcFunc['db_free_result']($result1);	
	asort($context['all_playlists']);
	$check_playlists = array();
	$result1 = array();
	$request = array();
	$myval = false;
	$a = false;
	
	foreach ($context['all_playlists'] as $myval)
		{			
			$a = check_playlist($myval);
			if ($a == false)
				{					
					$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_settings WHERE myplaylist LIKE {string:list}',
														array('list' => $myval));
					$request = $smcFunc['db_query']('', "INSERT INTO {db_prefix}premiumbeat_settings (`myplaylist`, `height`, `width`, `autoplay`, `type`, `skin`) 
															VALUES ({int:val} , '210', '185', '1', '0', '000000')",array('val' => $myval,));
				}	
		}		
	$i = 0;	
	$result1 = $smcFunc['db_query']('', "SELECT myplaylist, height, width, autoplay, type, skin FROM {db_prefix}premiumbeat_settings																				
										WHERE (myplaylist > 0) ORDER BY myplaylist ASC");
	while ($val = $smcFunc['db_fetch_assoc']($result1))
		{	
			if ((empty($val['myplaylist']))) {continue;}	 
			if ($val['myplaylist'] == 0) {continue;}					
			foreach ($columns_settings as $sets)
				{
					if (empty($val[$sets])) {$val[$sets] = 0;} 
					$context['sets'][$i][$sets] = $val[$sets]; 	
				}				
			$i++;		
		}
	$smcFunc['db_free_result']($result1);	
	
	/* Double check to make sure the playlist exists in the main mp3 list - if not then delete it */	
	$reset_page = false;	
	foreach ($context['sets'] as $check)
	{
		$checkit = $check['myplaylist'];
		$perm1 = 'premiumbeat_playlist_' . $checkit;
		$mytableName2 = 'permissions';
		$checkit2 = false;
		$result2 = $smcFunc['db_query']('', "SELECT playlist FROM {db_prefix}premiumbeat_mp3s																				
											WHERE (playlist > 0) ORDER BY playlist ASC");
		while ($val = $smcFunc['db_fetch_assoc']($result2))
			{	
				if ($val['playlist'] == $checkit) {$checkit2 = true;}
			}
		$smcFunc['db_free_result']($result2);		
		if ($checkit2 == false)
			{
				$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_settings WHERE myplaylist LIKE {string:list}',
														array('list' => $checkit));
				$request = $smcFunc['db_query']('', "DELETE FROM `{db_prefix}$mytableName2` WHERE `{db_prefix}$mytableName2`.`permission` = '$perm1'");								
				$reset_page = true;
				continue;										
			}				
	}		
	
	if ($reset_page == true) {redirectexit('action=admin;area=premiumbeat;sa=SettingsPremiumbeat;' . $context['session_var'] . '=' . $context['session_id'] . ';');}	
	
	/* Query playlist permissions */
	$result2 = array();	
	$context['group_names'][] = array();	
	$z = 0;
	$result2 = $smcFunc['db_query']('', 'SELECT	id_group, group_name FROM {db_prefix}membergroups WHERE id_group > 0 ORDER BY id_group');
	while ($val = $smcFunc['db_fetch_assoc']($result2))
			{
				if ((int)$val['id_group'] < 1) {continue;}
				$id = $val['id_group'];
				if (empty($val['group_name'])) {$val['group_name'] = false;}				
				$context['group_names'][$id] = substr($val['group_name'], 0, 60);
				$context['groups'][$z] = substr($val['group_name'], 0, 60);
				$context['group_id'][$z] = $id;
				$z++;
			}
	$smcFunc['db_free_result']($result2);
	$z = 0;
	foreach ($context['sets'] as $check)
	{
		$playlist = $check['myplaylist'];
		$context['id_group'][$playlist] = false;		
		$allow = 'premiumbeat_playlist_'. $playlist;
		$groups = groupsAllowedTo($allow);		
		$check_group = array_unique($groups['allowed']);
		if (empty($check_group[1])) {$check_group[1] = 0;}	
		if ($check_group[1] == false) {$context['id_group'][$playlist] = $txt['premiumbeat_na'];continue;}		
		foreach ($check_group as $groupid)
		{
			if ((int)$groupid == 0 || (int)$groupid == 1) {continue;}
			if ((int)$groupid == 999) {$context['id_group'][$playlist] .= $context['groups'][0] . ', '; continue;}
			if ((int)$groupid == -1) {$context['id_group'][$playlist] .= $txt['guest_title'] . ', '; continue;}			
			$group = $context['group_names'][$groupid];	
			if ($group == false) {$context['id_group'][$playlist] = $txt['premiumbeat_na'];continue;}								
			$context['id_group'][$playlist] .= $group . ', ';
			$context['premium_groups'][$z] = $group;			
		}
		$context['id_group'][$playlist] = rtrim($context['id_group'][$playlist], ', ');
		$z++;	
	}									
	/*  Display all the mp3 playlist settings  */	
	$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat;sa=SettingsPremiumbeat;' . $context['session_var'] . '=' . $context['session_id'] . ';';
    $context['sub_template'] = 'customMusic_settings';	
	loadTemplate('CustomMusicSettings');	
  }
 
function PlaylistCustomMusic()

	{
		global $txt, $scripturl, $context, $smcFunc, $sourcedir;
		loadLanguage('Modifications');	
		$context['robot_no_index'] = true;	
		isAllowedTo('premiumbeat_config');
		$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['customMusic_tabtitle4'];
		$a = false;		
		$count = 0;
		$context['mysets'] = array();
		$result1 = array();
		$checkit = false;
		$columns_settings = array('myplaylist', 'type', 'height', 'width', 'autoplay', 'skin');
		$context['template'] = 'CustomMusicPlaylist';
		$context['sub_template'] = 'customMusic_edit_playlist';
		$check_track = !empty($_REQUEST['playlist']) ? (int) $_REQUEST['playlist'] : 0;
		$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat;sa=SettingsPremiumbeat;' . 'playlist=' . (int)$check_track . ';' . $context['session_var'] . '=' . $context['session_id'] . ';save'; 
		require_once($sourcedir . '/Subs-Members.php');
		/* Query playlist permissions */
	$result2 = array();	
	$context['group_names'][] = array();	
	$z = 0;
	$result2 = $smcFunc['db_query']('', 'SELECT	id_group, group_name FROM {db_prefix}membergroups WHERE id_group > 0 ORDER BY id_group');
	while ($val = $smcFunc['db_fetch_assoc']($result2))
			{
				if ((int)$val['id_group'] < 1) {continue;}
				$id = $val['id_group'];
				if (empty($val['group_name'])) {$val['group_name'] = false;}				
				$context['group_names'][$id] = substr($val['group_name'], 0, 60);
				$context['groups'][$z] = substr($val['group_name'], 0, 60);
				$context['group_id'][$z] = $id;
				if ($id == 0) {$context['group_id'][$z] = 999;}
				$z++;
			}
	$smcFunc['db_free_result']($result2);	
	
	$allow = 'premiumbeat_playlist_'. $check_track;
	$groups = groupsAllowedTo($allow);		
	$check_group = array_unique($groups['allowed']);
	$context['id_group'] = false;
	if (empty($check_group[1])) {$check_group[1] = 0;}
		if ($check_group[1] == false) {$context['id_group'] = $txt['premiumbeat_na'];}		
		foreach ($check_group as $groupid)
		{
			if ((int)$groupid == 0 || (int)$groupid == 1) {continue;}
			if ((int)$groupid == 999) {$context['id_group'] .= $context['groups'][0] . ', '; continue;}
			if ((int)$groupid == -1) {$context['id_group'] .= $txt['guest_title'] . ', '; continue;}			
			$group = $context['group_names'][$groupid];	
			if ($group == false) {$context['id_group'] = $txt['premiumbeat_na'];continue;}								
			$context['id_group'] .= $group . ', ';
			$context['premium_groups'] = $group;			
		}
		$context['id_group'] = rtrim($context['id_group'], ', ');
					
		/*  Check if we're editing a specific playlist  */		
		if ($check_track > 0) 
			{$checkit = check_playlist($check_track);} 		
		$a = checkFieldPremium2('premiumbeat_settings','myplaylist');		
		if ($a == false) {fatal_lang_error('customMusic_error2', false);}	
		/*  Check if viewing query specific playlist template  */
		if ($checkit == false)
			{
				$context['template'] = 'CustomMusicPlaylistQuery';
				$context['sub_template'] = 'customMusic_query_playlist';
				$context['mysets']['type'] = false;
				$context['mysets']['autoplay'] = false;				
				$context['post_url'] = $scripturl . '?action=custom_mp3;sa=SettingsPremiumbeat;save'; 
				$context['post_url'] = $scripturl . '?action=admin;area=premiumbeat;sa=SettingsPremiumbeat;' . $context['session_var'] . '=' . $context['session_id'] . ';save'; 
			}
		
		$i = 0;
		$result1 = $smcFunc['db_query']('', "SELECT myplaylist, height, width, autoplay, type, skin FROM {db_prefix}premiumbeat_settings 
												WHERE (myplaylist = {$check_track}) LIMIT 1");
		while ($val = $smcFunc['db_fetch_assoc']($result1))
		{	
			if ((empty($val['myplaylist']))) {continue;}	 
			if ((int)$val['myplaylist'] < 1) {continue;}
			foreach ($columns_settings as $sets)
				{
					if (empty($val[$sets])) {$val[$sets] = 0;} 
					$context['mysets'][$sets] = $val[$sets]; 	
				}				
			$i++;		
		}
	$smcFunc['db_free_result']($result1);			
	
	/*  Display the edit template for the opted playlist settings */    
	$context['xtype'] = $txt['premiumbeat_shuffle'];
	$context['xauto'] = $txt['premiumbeat_disabled'];
	if ($context['mysets']['type'] == 1) {$context['xtype'] = $txt['premiumbeat_asc'];}	
	if ($context['mysets']['autoplay'] == 1) {$context['xauto'] = $txt['premiumbeat_enabled'];}
	$context['toggle'] = '<script type="text/javascript">
	function changeTypeA(){
 	  document.getElementById("updateDir").innerHTML = "Ascend";
	}
	function changeTypeS(){
 	  document.getElementById("updateDir").innerHTML = "Shuffle";
	}
	function changeAutoD(){
	   document.getElementById("updateAuto").innerHTML = "Enabled";
	}
	function changeAutoE(){
 	  document.getElementById("updateAuto").innerHTML = "Disabled";
	}
	function showPermissions()
	{
		document.getElementById("perm1").style.visibility="visible";
	}
	function Check(chk)
	{
		if(document.myselect.Check_All.value=="Check All")
		{
			for (i = 0; i < (chk.length - 1); i++)
			chk[i].checked = true ;
			document.myselect.Check_All.value="UnCheck All";
		}
		else
		{
			for (i = 0; i < (chk.length - 1); i++)
			chk[i].checked = false ;
			document.myselect.Check_All.value="Check All";
		}
	}
	</script>'; 	
	loadTemplate($context['template']);
	}
	  
/* Check if the column exists */
function checkFieldPremium2($tableName,$columnName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium2($tableName);
		if ($checkTable == true)
			{
				global $db_prefix, $smcFunc;
				$check = false;
				$checkval = false;
				$check = $smcFunc['db_query']('', "DESCRIBE {$db_prefix}$tableName $columnName");
				$checkval = $smcFunc['db_num_rows']($check);
				$smcFunc['db_free_result']($check);
				if ($checkval > 0) {return true;}
			}
		return false;
	} 

/*  Check if table exists  */
function check_table_existsPremium2($table)
	{
		global $db_prefix, $smcFunc;
		$check = false;
		$checkval = false;
		$check = $smcFunc['db_query']('', "SHOW TABLES LIKE '{$db_prefix}$table'");
		$checkval = $smcFunc['db_num_rows']($check);
		$smcFunc['db_free_result']($check);
		if ($checkval >0) {return true;}
		return false;
	}

function check_playlist($play)
	{
		global $db_prefix, $smcFunc;		
		$result2 = $smcFunc['db_query']('', "SELECT myplaylist FROM {db_prefix}premiumbeat_settings WHERE myplaylist = {$play} LIMIT 1");
		$result3 = $smcFunc['db_num_rows']($result2);	
		$smcFunc['db_free_result']($result2);		
		if ($result3 > 0) {return true;}
		return false;
	}	
	
function check_mp3($tag)
	{
		global $db_prefix, $smcFunc;		
		$result2 = $smcFunc['db_query']('', "SELECT tag FROM {db_prefix}premiumbeat_mp3s WHERE tag = {$tag} LIMIT 1");
		$result3 = $smcFunc['db_num_rows']($result2);	
		$smcFunc['db_free_result']($result2);		
		if ($result3 > 0) {return true;}
		return false;
	}			

/*  Update table -> column -> value for premiumbeat settings  */
function createpremiumval_settings($tableName, $columnName, $value, $playlist) 
	{
		global $smcFunc, $db_prefix;
		$i = 0;
		$request = false;   
		if (empty($tableName) || empty($columnName) || empty($playlist)) {return;}
		if (empty($value)) {$value = false;}
		$value2 = cleanPremiumbeatQuery2($value);
		$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value2}' WHERE `{$db_prefix}$tableName`.`myplaylist` = {$playlist} LIMIT 1");
								 
	}

/*  Update table -> column -> value for premiumbeat mp3 list  */
function createpremiumval_mp3($tableName, $columnName, $tag, $value) 
	{
		global $smcFunc, $db_prefix;
		$i = 0;
		$request = false;   
		if (empty($tableName) || empty($columnName) || empty($tag)) {return;}
		if (empty($value)) {$value = false;}
		$value2 = cleanPremiumbeatQuery2($value);
		$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value2}' WHERE `{$db_prefix}$tableName`.`tag` = {$tag} LIMIT 1");
								 
	}	
	
/* mysql query filter */
function cleanPremiumbeatQuery2($string)
{
  if(get_magic_quotes_gpc())  
  {
    $string = stripslashes($string);
  }
  if (phpversion() >= '4.3.0')
  {
    $string = mysql_real_escape_string($string);
  }
  else
  {
    $string = mysql_escape_string($string);
  }
  return $string;
}	

/* Filter input for hex color */
function premium_hex_filter($color)
{
	    if ($color[0] == '#')
        $color = substr($color, 1);

    if (strlen($color) == 6)
        list($r, $g, $b) = array($color[0].$color[1],
                                 $color[2].$color[3],
                                 $color[4].$color[5]);
    elseif (strlen($color) == 3)
        list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
    else
        return false;

    $r = hexdec($r); $g = hexdec($g); $b = hexdec($b);
	    if (is_array($r) && sizeof($r) == 3)
        list($r, $g, $b) = $r;

    $r = intval($r); $g = intval($g);
    $b = intval($b);

    $r = dechex($r<0?0:($r>255?255:$r));
    $g = dechex($g<0?0:($g>255?255:$g));
    $b = dechex($b<0?0:($b>255?255:$b));

    $color = (strlen($r) < 2?'0':'').$r;
    $color .= (strlen($g) < 2?'0':'').$g;
    $color .= (strlen($b) < 2?'0':'').$b;
    return $color;
}
?>