<?php
/*
    <id>premiumbeat:mp3forsmf</id>
	<name>Premiumbeat Flash MP3 Player For SMF Forums</name>
	<version>1.9</version>
	<type>modification</type>
*/	

/*  This file is for mysql setup and transferring possible values from v1.71 or prior versions */


/* START - Mysql setup and transfers  */
global $modSettings, $smcFunc, $db_prefix, $context, $scripturl;

echo '<div style="background-color:black; border: 2px dotted green; display: block; height: auto; width: 75%; font-family:verdana; font-size:small; font-color: yellow; padding: 20px 20px 20px 20px;margin-left: auto; margin-right: auto;color: green;"><br />Premiumbeat Mp3 Player For SMF Forums.<br /><br />This installation copies older mysql values from your settings table to premiumbeat tables and neatly drops them from your settings table if necessary.<br /><hr /><br />';    

/*  Set variables and arrays  */
$mymusic = array();
$music = array();
$myset = array();
$setting['variable'] = array();
$setting['value'] = array();
$max = 9999;
$counter = 1;
$tally = 0;
$types = array('tag', 'playlist', 'enable', 'description', 'url');
$sets = array('myplaylist', 'height', 'width', 'autoplay', 'type', 'skin');
$forum_sets = array('reference', 'override', 'filename', 'forumlink', 'autoplay');

$new_columnsTypes = array(
                          'premiumbeat_mp3s' => array ('int(10) unsigned NOT NULL AUTO_INCREMENT', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL default 0', 'varchar(255) NOT NULL', 'varchar(255) NOT NULL'),				
		                  'premiumbeat_settings' => array ('int(10) unsigned NOT NULL AUTO_INCREMENT', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'int(10) unsigned NOT NULL', 'varchar(255) NOT NULL'),
						  'premiumbeat_forum_settings' => array('int(10) unsigned NOT NULL AUTO_INCREMENT', 'varchar(255) NOT NULL', 'varchar(255) NOT NULL', 'int(10) unsigned NOT NULL', 'varchar(255) NOT NULL'));				

/*  Create premiumbeat tables if they do not exist  */
$checkit = false;
$table = 'premiumbeat_mp3s';
$checkit = check_table_existsPremium($table);
if ($checkit == false)
	{
		$result = $smcFunc['db_query']('', "CREATE TABLE {$db_prefix}{$table} 
                                       (
										`tag` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
										`playlist` INT(10) UNSIGNED NOT NULL,
										`enable` int(10) unsigned NOT NULL default 0,
										`description` varchar(255) NOT NULL,
										`url` varchar(255) NOT NULL,
										PRIMARY KEY (`tag`))");
		echo '<br />Table: ', $table, ' -> created with needed columns<br /><br /><hr />';
	}

$table = 'premiumbeat_settings';
$checkit = false;
$checkit = check_table_existsPremium($table);

if ($checkit == false) 
	{
		$result = $smcFunc['db_query']('', "CREATE TABLE {$db_prefix}{$table} 
								(
									`myplaylist` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
										`height` INT(10) UNSIGNED NOT NULL,
										`width` int(10) unsigned NOT NULL,
										`autoplay` int(10) unsigned NOT NULL,
										`type` int(10) unsigned NOT NULL,
										`skin` varchar(255) NOT NULL,
										PRIMARY KEY (`myplaylist`))");	

		echo '<br />Table: ', $table, ' -> created with needed columns<br />';
	}
$table = 'premiumbeat_forum_settings';
$checkit = false;
$checkit = check_table_existsPremium($table);

if ($checkit == false) 
	{
		$result = $smcFunc['db_query']('', "CREATE TABLE {$db_prefix}{$table} 
								(
									`reference` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,										
										`override` varchar(255) NOT NULL,
										`filename` varchar(255) NOT NULL,
										`forumlink` int(10) unsigned NOT NULL,
										`autoplay` varchar(255) NOT NULL,										
										PRIMARY KEY (`reference`))");	

		echo '<br />Table: ', $table, ' -> created with needed columns<br />';
	}
		
/*  Add extra needed columns into existing tables for columns only native to Premiumbeat  */
/*  This is necessary due to possible manual deletion or otherwise  */
$tableName = 'premiumbeat_settings';	
$request = false;
$i = 0;
$columnName = false;
foreach ($sets as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = $smcFunc['db_query']('', "ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType");					
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}			   
		    
$tableName = 'premiumbeat_mp3s';	
$request = false;
$i = 0;
$columnName = false;
foreach ($types as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = $smcFunc['db_query']('', "ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType");					
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}	

$tableName = 'premiumbeat_forum_settings';	
$request = false;
$i = 0;
$columnName = false;
foreach ($forum_sets as $columnName)
	{
		$a = false;                           
		$columnType = $new_columnsTypes[$tableName][$i];
		$a = checkFieldPremium($tableName,$columnName);			   
		if ($a == false)
			{			             
				$request = $smcFunc['db_query']('', "ALTER TABLE {$db_prefix}$tableName ADD $columnName $columnType");					
				echo $columnName, ' - added to table - ', $tableName,'<br /><br />';                                        
			}	 				   
		$i++;
	}			   

/*  Create needed reference if it does not exist  */
$a = false;
$tag = 1;
$a = check_ref($tag);
if ($a == false)
	{
		$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_forum_settings WHERE reference LIKE {string:like}', array('like' => $tag));
		$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}premiumbeat_forum_settings` (`reference`, `override`, `filename`, `forumlink`, `autoplay`) VALUES ('1', '1', 'my_music/music', '1', '99')");		
	}
			   
echo '<br /><hr />';

/*  Insert/reset default permission values  */
$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}permissions WHERE permission LIKE {string:like}', array('like' => 'premiumbeat_config'));
$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}permissions` (`id_group`, `permission`, `add_deny`) VALUES ('2', 'premiumbeat_config', '1')");		
$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}permissions WHERE permission LIKE {string:like}', array('like' => 'premiumbeat_settings'));
$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}permissions` (`id_group`, `permission`, `add_deny`) VALUES ('2', 'premiumbeat_settings', '1')");
$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}permissions WHERE permission LIKE {string:like}', array('like' => 'premiumbeat_showlink'));
$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}permissions` (`id_group`, `permission`, `add_deny`) VALUES ('2', 'premiumbeat_showlink', '1')");				
echo 'Premiumbeat Administration Permissions inserted/reset for Global Moderators and Admin staff<br /><br />';
echo '<br /><hr />';

/* Insert/rest default link setting */
$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}settings WHERE variable LIKE {string:like}', array('like' => 'premiumbeat_link'));
$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}settings` (`variable`, `value`) VALUES ('premiumbeat_link', '1')");		
echo 'Premiumbeat main setting for the popup link enabled<br /><br />';

/*  Check for v1.71 (or prior) mp3's and settings - drop them and put into arrays */
foreach ($sets as $set)
	{
	if (!empty($modSettings['customMusic_'.$set])) 
		{
			$myset[$set]  = $modSettings['customMusic_'.$set];
			$smcFunc['db_query']('', 'DELETE FROM {db_prefix}settings WHERE variable = {string:kind}',
										array('kind' => 'customMusic_'.$set,));
		}
	else {$myset[$set] = 0;}
	}

if ($myset['skin'] == 0) {$myset['skin'] = '000000';}
$tally = 0;
while ($counter < $max)
	{
		foreach ($types as $type)
			{
				if (!empty($modSettings['customMusic_'.$type.'_'.$counter]))
 					{
						$tally = $counter;
						$music[$type][$counter] = $modSettings['customMusic_'.$type.'_'.$counter]; $tally = $counter;
						$smcFunc['db_query']('', 'DELETE FROM {db_prefix}settings WHERE variable LIKE {string:like}',
													array('like' => 'customMusic_%_' . $counter,));
					}

			}
		$counter++;
	}

/*  Alter existing premiumbeat tables/columns with mp3's and settings from v1.71 (or prior)  */
$result1 = array();
$val = array();
$mp3_setting['tag'] = array();
$amt_values = 0;
$a = false;
$a = checkFieldPremium('premiumbeat_mp3s','tag');
if ($a == true)
	{
		$result1 = $smcFunc['db_query']('', "SELECT * FROM {db_prefix}premiumbeat_mp3s");
		$amt_values = $smcFunc['db_num_rows']($result1); 
		$smcFunc['db_free_result']($result1);
	}
$x = 0;
if ($amt_values > 0)
	{   
		$x = 1;      
		$result = $smcFunc['db_query']('', 'SELECT tag FROM {db_prefix}premiumbeat_mp3s ORDER BY tag ASC');      
		while ($val = $smcFunc['db_fetch_assoc']($result))
			{                               
				$mp3_setting['tag'][$x] = $x;                			
				$x++;
			}  
		$smcFunc['db_free_result']($result);
	}

$tableName = 'premiumbeat_mp3s';
$columnName = 'tag';
$check = false;
$x = 1;
while ($x < ($tally+1))
	{
		if (empty($music['tag'][$x])) {$music['tag'][$x] = false;}
		$value = $music['tag'][$x];
		if (empty($mp3_setting['tag'][$x])) {$mp3_setting['tag'][$x] = false;}
		if (empty($music['playlist'][$x])) {$music['playlist'][$x] = 0;}
		$music['playlist'][$x]++;
		if ($value == true)
			{
				$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_mp3s WHERE tag LIKE {string:like}',
														array('like' => $value));
				$request = $smcFunc['db_query']('', "INSERT INTO `{$db_prefix}premiumbeat_mp3s` (`tag`) VALUE ('$value')");
			}
		$x++;
	}
$count = 1;
if ($tally > 0)
	{
		while ($count < ($tally + 1))
			{
				$tableName = 'premiumbeat_mp3s';
				foreach ($types as $columnName)
					{
						if ($columnName == 'enable' && empty($music['enable'][$count])) 
							{$music['enable'][$count] = false;}
						if ($columnName == 'enable' && ($music['enable'][$count] == false) && ($music['tag'][$count] == true)) 
							{createpremiumval($tableName, $columnName, '0', $count);}
						elseif (($columnName == 'playlist') && ($music['playlist'][$count] == 1) && ($music['tag'][$count] == true))
							{
								$a = $music['playlist'][$count];
								createpremiumval($tableName, 'playlist', $a, $count);
							} 
						elseif ((!empty($music[$columnName][$count])) && ($music['tag'][$count] == true))
							{
								$value = $music[$columnName][$count];
								if ($columnName == true)
									{createpremiumval($tableName, $columnName, $value, $count);} 
							}
					}
				$count++;
				echo '<hr />';
			}
	}
$a = false;
$tally2 = 0;
$a = checkFieldPremium('premiumbeat_mp3s','tag');
if ($a == true)
	{
		$result1 = $smcFunc['db_query']('', "SELECT * FROM {db_prefix}premiumbeat_mp3s");
		$tally2 = $smcFunc['db_num_rows']($result1); 
		$smcFunc['db_free_result']($result1);
	}


/*  Create default settings for playlist 1 if they do not exist  */
$result1 = array();
$amt_values = 0;
$a = false;
$playlist = 1;
$a = checkFieldPremium('premiumbeat_settings','myplaylist');
if ($a == true)
	{
		$result1 = $smcFunc['db_query']('', "SELECT myplaylist FROM {db_prefix}premiumbeat_settings WHERE myplaylist = 1");
		while ($val1 = $smcFunc['db_fetch_assoc']($result1))
			{
				$check = false;
				if (empty($val1['myplaylist'])) {$val1['myplaylist'] = false;}
				if ($val1['myplaylist'] == 1)	{$check = true;}
			}
		$smcFunc['db_free_result']($result1);
	
	if ($check == false)
		{   
	    	$myval = 1;
			$request = $smcFunc['db_query']('', 'DELETE FROM {db_prefix}premiumbeat_settings WHERE myplaylist LIKE {string:list}',
														array('list' => $myval));
			$request = $smcFunc['db_query']('', "INSERT INTO {db_prefix}premiumbeat_settings (`myplaylist`, `height`, `width`, `autoplay`, `type`, `skin`) VALUES ('1', '190', '220', '0', '0', '000000')");		
		}
	echo '<hr /><br />Default settings for playlist 1 have been set/modified.<br />';
	}
echo '<hr /><br />Installation complete.<br /><br />Please adjust necessary settings and add your source mp3 url from the Admin page.<br /><br />';
echo '<div style="text-align:center;"><a href="'. $scripturl . '?action=admin;area=premiumbeat;">Configure Premiumbeat</a>  -  <a href="'. $scripturl .'?action=admin">Administration</a>  -  <a href="'. $scripturl .'">Forum</a><br /><br />** You will be redirected to Premiumbeat Configuration in 10 seconds **</div><br /><br /></div><br /><br />';
$time = 10; 
$url = $scripturl . '?action=admin;area=premiumbeat;';
@header("Refresh: $time; url=$url"); 
/* END - Mysql setup and transfers  */

/* Check if the column exists */
function checkFieldPremium($tableName,$columnName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium($tableName);
		if ($checkTable == true)
			{
				global $db_prefix, $smcFunc;
				$check = false;
				$checkval = false;
				$check = $smcFunc['db_query']('', "DESCRIBE {$db_prefix}$tableName $columnName");
				$checkval = $smcFunc['db_num_rows']($check);
				$smcFunc['db_free_result']($check);
				if ($checkval > 0) {return true;}
			}
		return false;
	} 

/*  Returns amount of columns in a table  */
function checkTablePremium($tableName)
	{
		$checkTable = false;
		$checkTable = check_table_existsPremium($tableName);
		if ($checkTable == true)
			{
				global $db_prefix, $smcFunc;
				$check = false;
				$checkval = false;
				$check = $smcFunc['db_query']('', "DESCRIBE {$db_prefix}$tableName");
				$checkval = $smcFunc['db_num_rows']($check);
				$smcFunc['db_free_result']($check);
				if ($checkval > 0) {return $checkval;}
			}
		return false;
	} 

/*  Check if table exists  */
function check_table_existsPremium($table)
	{
		global $db_prefix, $smcFunc;
		$check = false;
		$checkval = false;
		$check = $smcFunc['db_query']('', "SHOW TABLES LIKE '{$db_prefix}$table'");
		$checkval = $smcFunc['db_num_rows']($check);
		$smcFunc['db_free_result']($check);
		if ($checkval >0) {return true;}
		return false;
	}


/*  Update table -> column -> value   */
function createpremiumval($tableName, $columnName, $value, $tag) 
	{
		global $smcFunc, $db_prefix;
		$i = 0;
		$request = false;   
		if (empty($tableName) || empty($columnName) || empty($tag)) {return;}
		if (empty($value)) {$value = false;}
		$request = $smcFunc['db_query']('', "UPDATE {$db_prefix}$tableName SET $columnName = '{$value}' WHERE `{$db_prefix}$tableName`.`tag` = {$tag} LIMIT 1");
		echo 'Song id: ', $tag, ' ', $columnName, ': ', $value, ' - updated in - ', $tableName,'<br />'; 						 
	}

/* Check for reference value */
function check_ref($tag)
	{
		global $db_prefix, $smcFunc;		
		$result2 = $smcFunc['db_query']('', "SELECT reference FROM {db_prefix}premiumbeat_forum_settings WHERE reference = {$tag} LIMIT 1");
		$result3 = $smcFunc['db_num_rows']($result2);	
		$smcFunc['db_free_result']($result2);		
		if ($result3 > 0) {return true;}
		return false;
	}	
?>